HDU 1097 A hard puzzle(快速幂)

Problem Description

lcy gives a hard puzzle to feng5166,lwg,JGShining and Ignatius: gave a and b,how to know the a^b.everybody objects to this BT problem,so lcy makes the problem easier than begin.
this puzzle describes
that: gave a and b,how to know the a^b‘s the last digit number.But everybody is
too lazy to slove this problem,so they remit to you who is wise.

Input

There are mutiple test cases. Each test cases consists
of two numbers a and b(0<a,b<=2^30)

Output

For each test case, you should output the a^b‘s last
digit number.

 

Sample Input

7 66

8 800

Sample Output

9 6

一开始这道题,就想,乘法取模嘛,然后超时,然后想起还有一直东西叫快速幂的(觉得百度百科写的挺详细的,当时就是从那里学的)

 1 #include<cstdio>
 2 int mod(int a,int b){
 3     int ans=1;
 4     a=a%10;
 5     while(b>0){
 6         if(b&1) //如果b是基数,位运算
 7             ans=(ans*a)%10;
 8         b>>=1;//b/2
 9         a=(a*a)%10;
10     }
11     return ans;
12 }
13 int main(){
14     int a,b;
15     while(scanf("%d%d",&a,&b)==2)
16         printf("%d\n",mod(a,b));
17     return 0;
18 }

然后看别人的代码,发现还有一种,找规律

0,1,5,6的任意次循环,它的尾数都是它本身

2循环为:2,4,8,6

3循环为:3,9,7,1

4循环为:4,6

7循环为:7,9,3,1

8循环为:8,4,2,6

9循环为:9,1

当然你可以直接就用数组输出,你也可以把每一个数都当成有4次循环

 1 #include<stdio.h>
 2 int main()
 3 {    int a,b,c[4];
 4   while(scanf("%d%d",&a,&b)!=EOF)
 5   {
 6       a=a%10;
 7       c[0]=a;//一次
 8      c[1]=(c[0]*a)%10;//二次
 9      c[2]=(c[1]*a)%10;//三次
10      c[3]=(c[2]*a)%10;//四次
11      if(b%4==1)
12         printf("%d",c[0]);
13      if(b%4==2)
14         printf("%d",c[1]);
15      if(b%4==3)
16         printf("%d",c[2]);
17      if(b%4==0)
18         printf("%d",c[3]);
19     printf("\n");
20   }
21   return 0;
22 }

原文地址:https://www.cnblogs.com/cake-lover-77/p/10197890.html

时间: 2024-11-08 12:27:43

HDU 1097 A hard puzzle(快速幂)的相关文章

HDU 2604 Queuing (矩阵快速幂)

HDU 2604 Queuing (矩阵快速幂) ACM 题目地址:HDU 2604 Queuing 题意: n个人排队,f表示女,m表示男,包含子串'fmf'和'fff'的序列为O队列,否则为E队列,有多少个序列为E队列. 分析: 矩阵快速幂入门题. 下面引用巨巨解释: 用f(n)表示n个人满足条件的结果,那么如果最后一个人是m的话,那么前n-1个满足条件即可,就是f(n-1): 如果最后一个是f那么这个还无法推出结果,那么往前再考虑一位:那么后三位可能是:mmf, fmf, mff, fff

HDU 4686 Arc of Dream(快速幂矩阵)

题目链接 再水一发,构造啊,初始化啊...wa很多次啊.. #include <cstring> #include <cstdio> #include <string> #include <iostream> #include <algorithm> #include <vector> #include <queue> using namespace std; #define MOD 1000000007 #define

[2016-02-05][HDU][1097][A hard puzzle]

[2016-02-05][HDU][1097][A hard puzzle] HDU - 1097 A hard puzzle Time Limit: 1000MS Memory Limit: 32768KB 64bit IO Format: %I64d & %I64u Submit Status Description lcy gives a hard puzzle to feng5166,lwg,JGShining and Ignatius: gave a and b,how to know

HDU 2254 奥运(矩阵快速幂+二分等比序列求和)

HDU 2254 奥运(矩阵快速幂+二分等比序列求和) ACM 题目地址:HDU 2254 奥运 题意: 中问题不解释. 分析: 根据floyd的算法,矩阵的k次方表示这个矩阵走了k步. 所以k天后就算矩阵的k次方. 这样就变成:初始矩阵的^[t1,t2]这个区间内的v[v1][v2]的和. 所以就是二分等比序列求和上场的时候了. 跟HDU 1588 Gauss Fibonacci的算法一样. 代码: /* * Author: illuz <iilluzen[at]gmail.com> * B

HDU 2604 Queuing,矩阵快速幂

题目地址:HDU 2604 Queuing 题意: 略 分析: 易推出:   f(n)=f(n-1)+f(n-3)+f(n-4) 构造一个矩阵: 然后直接上板子: /* f[i] = f[i-1] + f[i-3] + f[i-4] */ #include<cstdio> #include<cstring> using namespace std; const int N = 4; int L, M; struct mtx { int x[N+1][N+1]; mtx(){ mem

hdu 2243 AC自动机 + 矩阵快速幂

// hdu 2243 AC自动机 + 矩阵快速幂 // // 题目大意: // // 给你一些短串,问在长度不超过k的任意串,包含至少一个这些短串的其中 // 一个.问这样的串有多少个. // // 解题思路: // // 首先, 包含和不包含是一种互斥关系,包含+不包含 = 全集u.全集的答案就是 // 26 ^ 1 + 26 ^ 2 + .... + 26 ^ k.不包含的比较好求.构建一个自动机,得到 // 一个转移矩阵A.表示状态i能到状态j的方法数.而这些状态中都是不包含所给的 //

HDU - 1097 - A hard puzzle (快速幂取模)

A hard puzzle Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 32633    Accepted Submission(s): 11672 Problem Description lcy gives a hard puzzle to feng5166,lwg,JGShining and Ignatius: gave a a

HDU 5950 Recursive sequence 矩阵快速幂

http://acm.hdu.edu.cn/showproblem.php?pid=5950 一开始以为i^4不能矩阵快速幂,但是结论是可以得,那么要怎么递推呢? 矩阵快速幂的思路都是一样的,matrix_a * matrix_b ^ n 其中,想要维护什么,就在matrix_a写,比如现在是F[n - 1], F[n - 2],我想要递推到下一项,那么就 会变成F[n], F[n - 1],这个时候,你就要寻找一下F[n]和F[n - 1]有什么关系. i^4也一样,想要从i^4 递推到 (i

HDU 2842 Chinese Rings(矩阵快速幂+递推)

题目地址:HDU 2842 这个游戏是一个九连环的游戏. 假设当前要卸下前n个环.由于要满足前n-2个都卸下,所以要先把前n-2个卸下,需要f(n-2)次.然后把第n个卸下需要1次,然后这时候要卸下第n-1个,然后此时前n-2个都已经被卸下了.这时候把前n-2个都卸下与都装上所需的次数是一样的,因为卸下与装上的规则是一样的.所以又需要f(n-2)次,这时候前n-1个都在上面,卸下前n-1个需要f(n-1)次. 所以,总共需要2*f(n-2)+f(n-1)+1次. 然后构造如下矩阵. 1,2,1